const {promisify} = require('util');
const aes = require('./helper/aes')
const {md5} = require('./helper/crypto')

const {defaultKey} = require('./config')

exports.authConnect = require('./helper/redis').connect

exports.authMiddleware = require('./middleware/auth')

exports.authSaveUser = async function(user) {
	user.token = aes.encode(`${user.id},${md5(user.id + user.password)}`, defaultKey)

	const setAsync = promisify(global.redisClient.set).bind(global.redisClient)
	await setAsync(`account:${user.id}`, JSON.stringify(user))
	return user
}

exports.detectToken = function(token, user) {
	const str = aes.decode(token, defaultKey)
	const arr = str.split(',')
	if (arr.length !== 2) {
		return false
	}

	const userid = arr[0]
	const secret = arr[1]
	const secr = md5(user.id + user.password)

	if (String(userid) !== String(user.id)) {
		return false
	}

	return secr === secret
}